Merge commit 'dkg/master'
[monkeysphere.git] / src / monkeysphere-server
1 #!/bin/bash
2
3 # monkeysphere-server: MonkeySphere server admin tool
4 #
5 # The monkeysphere scripts are written by:
6 # Jameson Rollins <jrollins@fifthhorseman.net>
7 #
8 # They are Copyright 2008, and are all released under the GPL, version 3
9 # or later.
10
11 ########################################################################
12 PGRM=$(basename $0)
13
14 SHARE=${MONKEYSPHERE_SHARE:="/usr/share/monkeysphere"}
15 export SHARE
16 . "${SHARE}/common" || exit 1
17
18 VARLIB="/var/lib/monkeysphere"
19 export VARLIB
20
21 # date in UTF format if needed
22 DATE=$(date -u '+%FT%T')
23
24 # unset some environment variables that could screw things up
25 unset GREP_OPTIONS
26
27 # default return code
28 RETURN=0
29
30 ########################################################################
31 # FUNCTIONS
32 ########################################################################
33
34 usage() {
35 cat <<EOF
36 usage: $PGRM <subcommand> [options] [args]
37 MonkeySphere server admin tool.
38
39 subcommands:
40  update-users (u) [USER]...          update user authorized_keys files
41
42  gen-key (g) [HOSTNAME]              generate gpg key for the server
43    -l|--length BITS                    key length in bits (2048)
44    -e|--expire EXPIRE                  date to expire
45    -r|--revoker FINGERPRINT            add a revoker
46  show-fingerprint (f)                show server's host key fingerprint
47  publish-key (p)                     publish server's host key to keyserver
48  diagnostics (d)                     report on the server's monkeysphere status
49
50  add-identity-certifier (a) KEYID    import and tsign a certification key
51    -n|--domain DOMAIN                  limit ID certifications to IDs in DOMAIN
52    -t|--trust TRUST                    trust level of certifier (full)
53    -d|--depth DEPTH                    trust depth for certifier (1)
54  remove-identity-certifier (r) KEYID remove a certification key
55  list-identity-certifiers (l)        list certification keys
56
57  gpg-authentication-cmd CMD          gnupg-authentication command
58
59  help (h,?)                          this help
60 EOF
61 }
62
63 su_monkeysphere_user() {
64     su --preserve-environment "$MONKEYSPHERE_USER" -- -c "$@"
65 }
66
67 # function to interact with the host gnupg keyring
68 gpg_host() {
69     local returnCode
70
71     GNUPGHOME="$GNUPGHOME_HOST"
72     export GNUPGHOME
73
74     # NOTE: we supress this warning because we need the monkeysphere
75     # user to be able to read the host pubring.  we realize this might
76     # be problematic, but it's the simplest solution, without too much
77     # loss of security.
78     gpg --no-permission-warning "$@"
79     returnCode="$?"
80
81     # always reset the permissions on the host pubring so that the
82     # monkeysphere user can read the trust signatures
83     chgrp "$MONKEYSPHERE_USER" "${GNUPGHOME_HOST}/pubring.gpg"
84     chmod g+r "${GNUPGHOME_HOST}/pubring.gpg"
85     
86     return "$returnCode"
87 }
88
89 # function to interact with the authentication gnupg keyring
90 # FIXME: this function requires basically accepts only a single
91 # argument because of problems with quote expansion.  this needs to be
92 # fixed/improved.
93 gpg_authentication() {
94     GNUPGHOME="$GNUPGHOME_AUTHENTICATION"
95     export GNUPGHOME
96
97     su_monkeysphere_user "gpg $@"
98 }
99
100 # update authorized_keys for users
101 update_users() {
102     if [ "$1" ] ; then
103         # get users from command line
104         unames="$@"
105     else
106         # or just look at all users if none specified
107         unames=$(getent passwd | cut -d: -f1)
108     fi
109
110     # set mode
111     MODE="authorized_keys"
112
113     # set gnupg home
114     GNUPGHOME="$GNUPGHOME_AUTHENTICATION"
115
116     # check to see if the gpg trust database has been initialized
117     if [ ! -s "${GNUPGHOME}/trustdb.gpg" ] ; then
118         failure "GNUPG trust database uninitialized.  Please see MONKEYSPHERE-SERVER(8)."
119     fi
120
121     # make sure the authorized_keys directory exists
122     mkdir -p "${VARLIB}/authorized_keys"
123
124     # loop over users
125     for uname in $unames ; do
126         # check all specified users exist
127         if ! getent passwd "$uname" >/dev/null ; then
128             log "----- unknown user '$uname' -----"
129             continue
130         fi
131
132         # set authorized_user_ids and raw authorized_keys variables,
133         # translating ssh-style path variables
134         authorizedUserIDs=$(translate_ssh_variables "$uname" "$AUTHORIZED_USER_IDS")
135         rawAuthorizedKeys=$(translate_ssh_variables "$uname" "$RAW_AUTHORIZED_KEYS")
136
137         # if neither is found, skip user
138         if [ ! -s "$authorizedUserIDs" ] ; then
139             if [ "$rawAuthorizedKeys" = '-' -o ! -s "$rawAuthorizedKeys" ] ; then
140                 continue
141             fi
142         fi
143
144         log "----- user: $uname -----"
145
146         # exit if the authorized_user_ids file is empty
147         if ! check_key_file_permissions "$uname" "$AUTHORIZED_USER_IDS" ; then
148             log "Improper permissions on authorized_user_ids file path."
149             continue
150         fi
151
152         # check permissions on the authorized_keys file path
153         if ! check_key_file_permissions "$uname" "$RAW_AUTHORIZED_KEYS" ; then
154             log "Improper permissions on authorized_keys file path path."
155             continue
156         fi
157
158         # make temporary directory
159         TMPDIR=$(mktemp -d)
160
161         # trap to delete temporary directory on exit
162         trap "rm -rf $TMPDIR" EXIT
163
164         # create temporary authorized_user_ids file
165         TMP_AUTHORIZED_USER_IDS="${TMPDIR}/authorized_user_ids"
166         touch "$TMP_AUTHORIZED_USER_IDS"
167
168         # create temporary authorized_keys file
169         AUTHORIZED_KEYS="${TMPDIR}/authorized_keys"
170         touch "$AUTHORIZED_KEYS"
171
172         # set restrictive permissions on the temporary files
173         # FIXME: is there a better way to do this?
174         chmod 0700 "$TMPDIR"
175         chmod 0600 "$AUTHORIZED_KEYS"
176         chmod 0600 "$TMP_AUTHORIZED_USER_IDS"
177         chown -R "$MONKEYSPHERE_USER" "$TMPDIR"
178
179         # if the authorized_user_ids file exists...
180         if [ -s "$authorizedUserIDs" ] ; then
181             # copy user authorized_user_ids file to temporary
182             # location
183             cat "$authorizedUserIDs" > "$TMP_AUTHORIZED_USER_IDS"
184
185             # export needed variables
186             export AUTHORIZED_KEYS
187             export TMP_AUTHORIZED_USER_IDS
188
189             # process authorized_user_ids file, as monkeysphere
190             # user
191             su_monkeysphere_user \
192                 ". ${SHARE}/common; process_authorized_user_ids $TMP_AUTHORIZED_USER_IDS"
193             RETURN="$?"
194         fi
195
196         # add user-controlled authorized_keys file path if specified
197         if [ "$rawAuthorizedKeys" != '-' -a -s "$rawAuthorizedKeys" ] ; then
198             log -n "adding raw authorized_keys file... "
199             cat "$rawAuthorizedKeys" >> "$AUTHORIZED_KEYS"
200             loge "done."
201         fi
202
203         # openssh appears to check the contents of the
204         # authorized_keys file as the user in question, so the
205         # file must be readable by that user at least.
206         # FIXME: is there a better way to do this?
207         chown root "$AUTHORIZED_KEYS"
208         chgrp $(getent passwd "$uname" | cut -f4 -d:) "$AUTHORIZED_KEYS"
209         chmod g+r "$AUTHORIZED_KEYS"
210
211         # move the resulting authorized_keys file into place
212         mv -f "$AUTHORIZED_KEYS" "${VARLIB}/authorized_keys/${uname}"
213
214         # destroy temporary directory
215         rm -rf "$TMPDIR"
216     done
217 }
218
219 # generate server gpg key
220 gen_key() {
221     local keyType
222     local keyLength
223     local keyUsage
224     local keyExpire
225     local revoker
226     local hostName
227     local userID
228     local keyParameters
229     local fingerprint
230
231     # set default key parameter values
232     keyType="RSA"
233     keyLength="2048"
234     keyUsage="auth"
235     keyExpire=
236     revoker=
237
238     # get options
239     TEMP=$(getopt -o l:e:r: -l length:,expire:,revoker: -n "$PGRM" -- "$@")
240
241     if [ $? != 0 ] ; then
242         exit 1
243     fi
244
245     # Note the quotes around `$TEMP': they are essential!
246     eval set -- "$TEMP"
247
248     while true ; do
249         case "$1" in
250             -l|--length)
251                 keyLength="$2"
252                 shift 2
253                 ;;
254             -e|--expire)
255                 keyExpire="$2"
256                 shift 2
257                 ;;
258             -r|--revoker)
259                 revoker="$2"
260                 shift 2
261                 ;;
262             --)
263                 shift
264                 ;;
265             *)
266                 break
267                 ;;
268         esac
269     done
270
271     hostName=${1:-$(hostname --fqdn)}
272     userID="ssh://${hostName}"
273
274     # check for presense of key with user ID
275     if gpg_host --list-key ="$userID" > /dev/null 2>&1 ; then
276         failure "Key for '$userID' already exists"
277     fi
278
279     # prompt about key expiration if not specified
280     if [ -z "$keyExpire" ] ; then
281         cat <<EOF
282 Please specify how long the key should be valid.
283          0 = key does not expire
284       <n>  = key expires in n days
285       <n>w = key expires in n weeks
286       <n>m = key expires in n months
287       <n>y = key expires in n years
288 EOF
289         while [ -z "$keyExpire" ] ; do
290             read -p "Key is valid for? (0) " keyExpire
291             if ! test_gpg_expire ${keyExpire:=0} ; then
292                 echo "invalid value"
293                 unset keyExpire
294             fi
295         done
296     elif ! test_gpg_expire "$keyExpire" ; then
297         failure "invalid key expiration value '$keyExpire'."
298     fi
299
300     # set key parameters
301     keyParameters=$(cat <<EOF
302 Key-Type: $keyType
303 Key-Length: $keyLength
304 Key-Usage: $keyUsage
305 Name-Real: $userID
306 Expire-Date: $keyExpire
307 EOF
308 )
309
310     # add the revoker field if specified
311     # FIXME: the "1:" below assumes that $REVOKER's key is an RSA key.
312     # FIXME: key is marked "sensitive"?  is this appropriate?
313     if [ "$revoker" ] ; then
314         keyParameters="${keyParameters}"$(cat <<EOF
315 Revoker: 1:$revoker sensitive
316 EOF
317 )
318     fi
319
320     echo "The following key parameters will be used for the host private key:"
321     echo "$keyParameters"
322
323     read -p "Generate key? (Y/n) " OK; OK=${OK:=Y}
324     if [ ${OK/y/Y} != 'Y' ] ; then
325         failure "aborting."
326     fi
327
328     # add commit command
329     keyParameters="${keyParameters}"$(cat <<EOF
330
331 %commit
332 %echo done
333 EOF
334 )
335
336     log "generating server key..."
337     echo "$keyParameters" | gpg_host --batch --gen-key
338
339     # output the server fingerprint
340     fingerprint_server_key "=${userID}"
341
342     # find the key fingerprint of the server primary key
343     fingerprint=$(gpg_host --list-key --with-colons --with-fingerprint "=${userID}" | \
344         grep '^fpr:' | head -1 | cut -d: -f10)
345
346     # export host ownertrust to authentication keyring
347     log "setting ultimate owner trust for server key..."
348     echo "${fingerprint}:6:" | gpg_authentication "--import-ownertrust"
349
350     # translate the private key to ssh format, and export to a file
351     # for sshs usage.
352     # NOTE: assumes that the primary key is the proper key to use
353     (umask 077 && \
354         gpg_host --export-secret-key "$fingerprint" | \
355         openpgp2ssh "$fingerprint" > "${VARLIB}/ssh_host_rsa_key")
356     log "Private SSH host key output to file: ${VARLIB}/ssh_host_rsa_key"
357 }
358
359 # gpg output key fingerprint
360 fingerprint_server_key() {
361     gpg_host --fingerprint --list-secret-keys
362 }
363
364 # publish server key to keyserver
365 publish_server_key() {
366     read -p "Really publish key to $KEYSERVER? (y/N) " OK; OK=${OK:=N}
367     if [ ${OK/y/Y} != 'Y' ] ; then
368         failure "aborting."
369     fi
370
371     # publish host key
372     # FIXME: need to figure out better way to identify host key
373     # dummy command so as not to publish fakes keys during testing
374     # eventually:
375     #gpg_authentication "--keyserver $KEYSERVER --send-keys $(hostname -f)"
376     echo "NOT PUBLISHED (to avoid permanent publication errors during monkeysphere development)."
377     echo "The following command should publish the key:"
378     echo "monkeysphere-server gpg-authentication-cmd '--keyserver $KEYSERVER --send-keys $(hostname -f)'"
379     exit 255
380 }
381
382 diagnostics() {
383 #  * check on the status and validity of the key and public certificates
384     local seckey
385     local keysfound
386     local curdate
387     local warnwindow
388     local warndate
389     local create
390     local expire
391     local uid
392     local fingerprint
393
394     seckey=$(gpg_host --list-secret-keys --fingerprint --with-colons --fixed-list-mode)
395     keysfound=$(echo "$seckey" | grep -c ^sec:)
396     curdate=$(date +%s)
397     # warn when anything is 2 months away from expiration
398     warnwindow='2 months'
399     warndate=$(date +%s -d "$warnwindow")
400
401     echo "Checking host GPG key..."
402     if (( "$keysfound" < 1 )); then
403         echo "! No host key found."
404         echo " - Recommendation: run 'monkeysphere-server gen-key'"
405     elif (( "$keysfound" > 1 )); then
406         echo "! More than one host key found?"
407         # FIXME: recommend a way to resolve this
408     else
409         create=$(echo "$seckey" | grep ^sec: | cut -f6 -d:)
410         expire=$(echo "$seckey" | grep ^sec: | cut -f7 -d:)
411         fingerprint=$(echo "$seckey" | grep ^fpr: | head -n1 | cut -f10 -d:)
412         # check for key expiration:
413         if [ "$expire" ]; then
414             if (( "$expire"  < "$curdate" )); then
415                 echo "! Host key is expired."
416                 # FIXME: recommend a way to resolve this other than re-keying?
417             elif (( "$expire" < "$warndate" )); then
418                 echo "! Host key expires in less than $warnwindow:" $(date -d "$(( $expire - $curdate )) seconds" +%F)
419                 # FIXME: recommend a way to resolve this?
420             fi
421         fi
422
423         # and weirdnesses:
424         if [ "$create" ] && (( "$create" > "$curdate" )); then
425             echo "! Host key was created in the future(?!). Is your clock correct?"
426             echo " - Recommendation: Check clock ($(date +%F_%T)); use NTP?"
427         fi
428
429         # check for UserID expiration:
430         echo "$seckey" | grep ^uid: | cut -d: -f6,7,10 | \
431         while IFS=: read create expire uid ; do
432             # FIXME: should we be doing any checking on the form
433             # of the User ID?  Should we be unmangling it somehow?
434
435             if [ "$create" ] && (( "$create" > "$curdate" )); then
436                 echo "! User ID '$uid' was created in the future(?!).  Is your clock correct?"
437                 echo " - Recommendation: Check clock ($(date +%F_%T)); use NTP?"
438             fi
439             if [ "$expire" ] ; then
440                 if (( "$expire" < "$curdate" )); then
441                     echo "! User ID '$uid' is expired."
442                         # FIXME: recommend a way to resolve this
443                 elif (( "$expire" < "$warndate" )); then
444                     echo "! User ID '$uid' expires in less than $warnwindow:" $(date -d "$(( $expire - $curdate )) seconds" +%F)                
445                     # FIXME: recommend a way to resolve this
446                 fi
447             fi
448         done
449             
450 # FIXME: verify that the host key is properly published to the
451 #   keyservers (do this with the non-privileged user)
452
453 # FIXME: check that there are valid, non-expired certifying signatures
454 #   attached to the host key after fetching from the public keyserver
455 #   (do this with the non-privileged user as well)
456
457 # FIXME: propose adding a revoker to the host key if none exist (do we
458 #   have a way to do that after key generation?)
459
460         # Ensure that the ssh_host_rsa_key file is present and non-empty:
461         echo "Checking host SSH key..."
462         if [ ! -s "${VARLIB}/ssh_host_rsa_key" ] ; then
463             echo "! The host key as prepared for SSH (${VARLIB}/ssh_host_rsa_key) is missing or empty."
464         else
465             if [ $(stat -c '%a' "${VARLIB}/ssh_host_rsa_key") != 600 ] ; then
466                 echo "! Permissions seem wrong for ${VARLIB}/ssh_host_rsa_key -- should be 0600."
467             fi
468
469             # propose changes needed for sshd_config (if any)
470             if ! grep -q "^HostKey ${VARLIB}/ssh_host_rsa_key$" /etc/ssh/sshd_config; then
471                 echo "! /etc/ssh/sshd_config does not point to the monkeysphere host key (${VARLIB}/ssh_host_rsa_key)."
472                 echo " - Recommendation: add a line to /etc/ssh/sshd_config: 'HostKey ${VARLIB}/ssh_host_rsa_key'"
473             fi
474         fi
475     fi
476
477 # FIXME: look at the ownership/privileges of the various keyrings,
478 #    directories housing them, etc (what should those values be?  can
479 #    we make them as minimal as possible?)
480
481 # FIXME: look to see that the ownertrust rules are set properly on the
482 #    authentication keyring
483
484 # FIXME:  make sure that at least one identity certifier exists
485
486 }
487
488 # retrieve key from web of trust, import it into the host keyring, and
489 # ltsign the key in the host keyring so that it may certify other keys
490 add_certifier() {
491     local domain
492     local trust
493     local depth
494     local keyID
495     local fingerprint
496     local ltsignCommand
497     local trustval
498
499     # set default values for trust depth and domain
500     domain=
501     trust=full
502     depth=1
503
504     # get options
505     TEMP=$(getopt -o n:t:d: -l domain:,trust:,depth: -n "$PGRM" -- "$@")
506
507     if [ $? != 0 ] ; then
508         exit 1
509     fi
510
511     # Note the quotes around `$TEMP': they are essential!
512     eval set -- "$TEMP"
513
514     while true ; do
515         case "$1" in
516             -n|--domain)
517                 domain="$2"
518                 shift 2
519                 ;;
520             -t|--trust)
521                 trust="$2"
522                 shift 2
523                 ;;
524             -d|--depth)
525                 depth="$2"
526                 shift 2
527                 ;;
528             --)
529                 shift
530                 ;;
531             *)
532                 break
533                 ;;
534         esac
535     done
536
537     keyID="$1"
538     if [ -z "$keyID" ] ; then
539         failure "You must specify the key ID of a key to add."
540     fi
541     export keyID
542
543     # get the key from the key server
544     gpg_authentication "--keyserver $KEYSERVER --recv-key '$keyID'"
545
546     # get the full fingerprint of a key ID
547     fingerprint=$(gpg_authentication "--list-key --with-colons --with-fingerprint $keyID" | \
548         grep '^fpr:' | grep "$keyID" | cut -d: -f10)
549
550     echo "key found:"
551     gpg_authentication "--fingerprint $fingerprint"
552
553     echo "Are you sure you want to add this key as a certifier of"
554     read -p "users on this system? (y/N) " OK; OK=${OK:-N}
555     if [ "${OK/y/Y}" != 'Y' ] ; then
556         failure "aborting."
557     fi
558
559     # export the key to the host keyring
560     gpg_authentication "--export $keyID" | gpg_host --import
561
562     if [ "$trust" == marginal ]; then
563         trustval=1
564     elif [ "$trust" == full ]; then
565         trustval=2
566     else
567         failure "trust value requested ('$trust') was unclear (only 'marginal' or 'full' are supported)"
568     fi
569
570     # ltsign command
571     # NOTE: *all* user IDs will be ltsigned
572     ltsignCommand=$(cat <<EOF
573 ltsign
574 y
575 $trustval
576 $depth
577 $domain
578 y
579 save
580 EOF
581         )
582
583     # ltsign the key
584     echo "$ltsignCommand" | gpg_host --quiet --command-fd 0 --edit-key "$fingerprint"
585
586     # update the trustdb for the authentication keyring
587     gpg_authentication "--check-trustdb"
588 }
589
590 # delete a certifiers key from the host keyring
591 remove_certifier() {
592     local keyID
593     local fingerprint
594
595     keyID="$1"
596     if [ -z "$keyID" ] ; then
597         failure "You must specify the key ID of a key to remove."
598     fi
599
600     # delete the requested key (with prompting)
601     gpg_host --delete-key "$keyID"
602
603     # update the trustdb for the authentication keyring
604     gpg_authentication "--check-trustdb"
605 }
606
607 # list the host certifiers
608 list_certifiers() {
609     gpg_host --list-keys
610 }
611
612 # issue command to gpg-authentication keyring
613 gpg_authentication_cmd() {
614     gpg_authentication "$@"
615 }
616
617 ########################################################################
618 # MAIN
619 ########################################################################
620
621 # unset variables that should be defined only in config file
622 unset KEYSERVER
623 unset AUTHORIZED_USER_IDS
624 unset RAW_AUTHORIZED_KEYS
625 unset MONKEYSPHERE_USER
626
627 # load configuration file
628 [ -e ${MONKEYSPHERE_SERVER_CONFIG:="${ETC}/monkeysphere-server.conf"} ] && . "$MONKEYSPHERE_SERVER_CONFIG"
629
630 # set empty config variable with ones from the environment, or with
631 # defaults
632 KEYSERVER=${MONKEYSPHERE_KEYSERVER:=${KEYSERVER:="subkeys.pgp.net"}}
633 AUTHORIZED_USER_IDS=${MONKEYSPHERE_AUTHORIZED_USER_IDS:=${AUTHORIZED_USER_IDS:="%h/.config/monkeysphere/authorized_user_ids"}}
634 RAW_AUTHORIZED_KEYS=${MONKEYSPHERE_RAW_AUTHORIZED_KEYS:=${RAW_AUTHORIZED_KEYS:="%h/.ssh/authorized_keys"}}
635 MONKEYSPHERE_USER=${MONKEYSPHERE_MONKEYSPHERE_USER:=${MONKEYSPHERE_USER:="monkeysphere"}}
636
637 # other variables
638 CHECK_KEYSERVER=${MONKEYSPHERE_CHECK_KEYSERVER:="true"}
639 REQUIRED_USER_KEY_CAPABILITY=${MONKEYSPHERE_REQUIRED_USER_KEY_CAPABILITY:="a"}
640 GNUPGHOME_HOST=${MONKEYSPHERE_GNUPGHOME_HOST:="${VARLIB}/gnupg-host"}
641 GNUPGHOME_AUTHENTICATION=${MONKEYSPHERE_GNUPGHOME_AUTHENTICATION:="${VARLIB}/gnupg-authentication"}
642
643 # export variables needed in su invocation
644 export DATE
645 export MODE
646 export MONKEYSPHERE_USER
647 export KEYSERVER
648 export CHECK_KEYSERVER
649 export REQUIRED_USER_KEY_CAPABILITY
650 export GNUPGHOME_HOST
651 export GNUPGHOME_AUTHENTICATION
652 export GNUPGHOME
653
654 # get subcommand
655 COMMAND="$1"
656 [ "$COMMAND" ] || failure "Type '$PGRM help' for usage."
657 shift
658
659 case $COMMAND in
660     'update-users'|'update-user'|'u')
661         update_users "$@"
662         ;;
663
664     'gen-key'|'g')
665         gen_key "$@"
666         ;;
667
668     'show-fingerprint'|'f')
669         fingerprint_server_key
670         ;;
671
672     'publish-key'|'p')
673         publish_server_key
674         ;;
675
676     'diagnostics'|'d')
677         diagnostics
678         ;;
679
680     'add-identity-certifier'|'add-certifier'|'a')
681         add_certifier "$1"
682         ;;
683
684     'remove-identity-certifier'|'remove-certifier'|'r')
685         remove_certifier "$1"
686         ;;
687
688     'list-identity-certifiers'|'list-certifiers'|'list-certifier'|'l')
689         list_certifiers "$@"
690         ;;
691
692     'gpg-authentication-cmd')
693         gpg_authentication_cmd "$@"
694         ;;
695
696     'help'|'h'|'?')
697         usage
698         ;;
699
700     *)
701         failure "Unknown command: '$COMMAND'
702 Type '$PGRM help' for usage."
703         ;;
704 esac
705
706 exit "$RETURN"